# Flappy bird racing

This is a [TINS 2023](https://tins.amarillion.org/2023) entry by [Victor Williams Stafusa da Silva](https://github.com/victorwss).

## How to run it?

Download everything in a folder and run the `flapp-bird-racing.html` into your browser.

## How is the game?

This is a multiplayer racing flappy bird game, although you may also play lonely if you want to, it's quite challenging.

The first player to reach the ending wins!

However, to reach the end, it will be a long and troublesome path full of hazards and enemies. Everything kills you in
a single step, so watchout. However, you have infinite lifes, and respawn a few seconds after the death, so you can
always try again until you do it.

First, choose if you want the easy mode (5 levels) or the hard mode (13 levels). They gets harder and harder.
Then, you also select how many players you want to have, from 1 to 6.

## The players

Although it might be problematic to fit more than two players in the screen.
But if you really want to, use your browser zoom-out feature to fit everything.

When you start the game, every bird will randomly pick a color and a language between
English, Spanish, French, German, Portuguese or Italian.

* Player 1 flaps with the Spacebar.
* Player 2 flaps with the Enter key.
* Player 3 flaps with the Numpad 5 key.
* Player 4 flaps with the Q key.
* Player 5 flaps with the P key.
* Player 6 flaps with the T key.

Fitting 6 people around a single keyboard is difficult, but by plugging an extra USB keyboard into your computer,
this becomes easy.

Also, clicking the screens with the mouse makes the corresponding bird flap,
so one of the players could use the mouse instead.

I didn't checked into touchscreen mobile devices, but it might work as well.
However, it is possible to have issues if not on single-player mode.

## The game starts

The game is a fable about birds that take a long journey to distant lands because... Well, just because!

When you start the game, you'll be flashing in iridescent colors for 5 seconds. During this time, you are unvulnerable.
This is important to avoid insta-death after respawning when there is a cat or some other hazard that would be
impassable otherwise.

The hazards are the ceiling, the floor, the platforms (movable on later levels), the bar charts and the enemies.

There are two enemies:

* The turtles - They sit quiet if you don't disturb them.
If you do disturb them, they will say something nasty and will spin around the screen killing every bird they touch.

* The cats - They like to jump and chase birds!
They will be one of your worst nightmares in this game!

Also, the game changes back and forth between the musics
"Learn to Fly" from Foo Fighters and "Iridescent" by Linkin' Park.
However, to avoid RIAA and non-free-content issues, they are just MID versions of the original songs converted to MP3.

Have a lot fun! Amusez-vous beaucoup ! ¡Diviértete mucho! Hab viel Spaß! Divirta-se bastante! Divertiti molto!

## Known issues

- The sounds are likely to fail to load in Safari due to lack of MP3 support.
Since every other browser does support MP3 and converting it might take a some time and space, I think it is ok.
I will do it later if there is demand.

- Not tested in mobile devices.

- Excessive memory and CPU usage.

- With two or more players, it might be difficulty to tell for sure which bird who is controlling.

- Add music and sound on/off buttons. The music might become annoying after some time.

- To avoid the control buttons capturing the Enter key, click the blank area in the page before playing.